<!DOCTYPE html>
<html xmlns:th="http://thymeleaf.org"
    th:replace="~{main-layout.html::main-fragment(~{::title},~{::#exemple-main-content})}">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" th:href="@{/webjars/bootstrap/5.3.2/css/bootstrap.min.css}" />
    <title>Exemple</title>
</head>

<body>
    <div class="container-fluid" id="exemple-main-content">
        <h1>Exemples</h1>

        <div class="alert alert-warning col-md-2" th:text="|compteur= ${compteur}|">compteur</div>

        <div class="alert alert-primary col-md-6 mt-3" th:if="${msg}" th:text="${msg}">le message</div>

        <div class="row">
            <div class="col-md-6">
                <h4>Controleur</h4>
                <ul>
                    <li><a th:href="@{/hello}">Helloworld</a></li>
                    <li><a th:href="@{/exemple/testmodel}">Model</a></li>
                    <li><a th:href="@{/exemple/testmodelandview}">ModelAndView</a></li>
                </ul>
                <h4>Request Mapping</h4>
                <ul>
                    <li><a th:href="@{/exemple/testparams(id=12)}">url avec paramètre id</a></li>
                    <li><a th:href="@{/exemple/testparams}"  class="text-danger">url sans paramètre => erreur</a></li>
                    <li><a th:href="@{/exemple/testparamsval(id=42)}">url avec paramètre id=42</a></li>
                    <li><a th:href="@{/exemple/testparamsVal(id=3)}" class="text-danger">url avec paramètre id=3 => erreur</a></li>
                    <li><a th:href="@{/exemple/testproduces}">url avec l’entête Accept qui contient text/plain</a></li>
                </ul>
                <h4>Path Variable</h4>
                <ul>
                    <li><a th:href="@{/exemple/testpath/2}">url /exemple/testpath/2</a></li>
                    <li><a th:href="@{/exemple/testpathimpl/2}">url /exemple/testpathimpl/2</a></li>
                    <li><a
                            th:href="@{/exemple/testpathmulti/42/action/ajouter}">url/exemple/testpathmulti/42/action/ajouter</a>
                    </li>
                    <li><a
                            th:href="@{/exemple/testpathmap/42/action/ajouter}">url/exemple/testpathmap/42/action/ajouter</a>
                    </li>
                    <li><a th:href="@{/exemple/testpathamb/42}">url avec /exemple/testpathamb/42</a></li>
                    <li><a th:href="@{/exemple/testpathamb/smithee}">url avec /exemple/testpathamb/Smithee</a></li>
                    <li><a th:href="@{/exemple/testpathoption}">url avec /exemple/testpathoption</a></li>
                    <li><a th:href="@{/exemple/testpathoption/123}">url avec /exemple/testpathoption/123</a></li>
                </ul>
                <h4>RequestParam</h4>
                <ul>
                    <li><a th:href="@{/exemple/testparam(id=23)}">test paramètre id=23</a></li>
                    <li><a th:href="@{/exemple/testparamimpl(id=23)}">test paramètre id=23 (implicite)</a></li>
                    <li><a th:href="@{/exemple/testparammulti(id=23,nom=johndoe)}">test paramètre multiple id=23
                            nom=johndoe</a></li>
                    <li><a th:href="@{/exemple/testparamamb(id=34)}">test paramètre id=34 (ambigue)</a></li>
                    <li><a th:href="@{/exemple/testparamamb(nom=johndoe)}">test paramètre nom=johndoe (ambigue)</a></li>
                    <li><a th:href="@{/exemple/testparamdefault(id=12)}">test paramètre par défaut id=12</a></li>
                    <li><a th:href="@{/exemple/testparamdefault}">test paramètre par défaut</a></li>
                    <li><a th:href="@{/exemple/testparamoption(id=42)}">test paramètre optionnel id=42</a></li>
                    <li><a th:href="@{/exemple/testparamoption}">test paramètre optionnel</a></li>
                    <li>
                        <h5>RequestParam avec un Formulaire methode http: post</h5>
                        <form method="post" th:action="@{/exemple/testformulaire}">
                            <label for="nom">Nom</label>
                            <input type="text" name="nom" id="nom">
                            <input type="submit" value="Confirmer">
                        </form>
                    </li>
                </ul>
                <h4>RequestHeader</h4>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/testheader}" />request header: user-agent</a></li>
                    <li><a class="my-2" th:href="@{/exemple/testallheader}" />all header</a></li>
                </ul>
                <ul class="list-group">
                    <li class="list-group-item" th:each="h : ${lstHeader}" th:text="${h}"></li>
                </ul>

                <h4>Lier les beans</h4>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/testbindpath/1/john/doe}" />Path :John Doe</a>
                    <li><a class="my-2" th:href="@{/exemple/testbindparam(id=4,prenom=alan,nom=smithee)}">Param : Alan
                            Smithee</a>
                </ul>
                <h4>Redirection et FlashAttribute</h4>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/testredirect}" />Test redirection(redirect) hello world</a>
                    </li>
                    <li><a class="my-2" th:href="@{/exemple/testforward}" />Test redirection(forward) hello world</a>
                    </li>
                    <li><a class="my-2" th:href="@{/exemple/testflash}" />Test flash attributes</a></li>
                </ul>
                </div>
                <div class="col-6 border-start">
                <h4>Erreurs et Exceptions</h4>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/fourofour}">Erreur 404</a></li>
                    <li><a class="my-2" th:href="@{/exemple/ioexception}">Générer une IOException</a></li>
                    <li><a class="my-2" th:href="@{/exemple/sqlexception}">Générer une SQLException</a></li>
                </ul>

                <h4>Upload Fichier</h4>
                <form method="post" th:action="@{/exemple/upload}" enctype="multipart/form-data">
                    <div class="mb-3">
                        <label for="upload-file" class="form-label">Fichier</label>
                        <input type="file" id="upload-file" name="upload-file" class="form-control" />
                    </div>
                    <input type="submit" value="Télécharger" class="btn btn-primary mb-3" />
                </form>
                <h4>Email</h4>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/testsimplemail}">Envoyer un mail</a>
                    <li><a class="my-2" th:href="@{/exemple/testhtmlmail}">Envoyer un mail HTML</a>
                    <li><a class="my-2" th:href="@{/exemple/testsimplemail}">Envoyer un mail avec un template thymleaf</a>
                    <li><a class="my-2" th:href="@{/exemple/testsimplemail}">Envoyer un mail avec une pièce jointe</a>                 
                </ul>
                <h4>Cookie</h4>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/readcookie}" />Lire la valeur dans le cookie testCookie</a>
                    </li>
                    <li><a class="my-2" th:href="@{/exemple/writecookie}" />Ecrire le cookie testCookie </a></li>
                </ul>
                <h4>Session</h4>
                <h5>Avec HttpSession:</h5>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/writesession1}" />Ecrire une personne personne1(Alan Smithee) dans la session</a></li>
                    <li><a class="my-2" th:href="@{/exemple/readsession1}" />Lire une personne personne1 dans la session</a></li>
                </ul>
                <h5>Avec @SessionAttribute, @ModelAttribute:</h5>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/writesession2}" />Ecrire une personne personne2(Jane Doe) dans la session</a></li>
                    <li><a class="my-2" th:href="@{/exemple/readsession2}" />Lire une personne personne2 dans la session</a></li>
                </ul>
                <h5>Avec un bean avec une portée session :</h5>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple/writesession3}" />Ecrire une personne personne3(John Doe) dans la session</a></li>
                    <li><a class="my-2" th:href="@{/exemple/readsession3}" />Lire une personne personne3 dans la session</a></li>
                </ul>
                <h4>Internationalisation</h4>
                <div class="alert alert-info" th:text="#{name.training}">Formation spring</div>
                <p>Changer la langue:</p>
                <ul>
                    <li><a class="my-2" th:href="@{/exemple?lang=fr}">Français: localhost:8080/exemple?lang=fr</a></li>
                    <li><a class="my-2" th:href="@{/exemple?lang=es}">Español: localhost:8080/exemple?lang=es</a></li>
                    <li><a class="my-2" th:href="@{/exemple?lang=de}">Deutsch:localhost:8080/exemple?lang=de</a></li>
                    <li><a class="my-2" th:href="@{/exemple?lang=en}">English :localhost:8080/exemple?lang=en</a></li>
                </ul>
            </div>
        </div>
    </div>
</body>

</html>